indexing
	title:       "Iterator-Pattern";
	cluster:     "";
	project:     "OOSE - Praktikum";
	copyright:   "";
	author:      "Jan Czischka";
	original:    ;
	version:     1.0;
	last_change: no_changes;
	done_at:     "";
	extrnl_name: ""

-- ?? soll datenbtyp allgemein sein ?? (Integer)

class tnode			               --class tnode
	creation init
	feature 	data:Integer;
				pNext:tnode;
   feature init is
   do
     pNext:=void;
     data:=0;
   end -- feature init

   feature setData(e:Integer) is
   do
     data:=e;
   end -- feature setpNext

   feature setpNext(p:tnode) is
   do
     pNext:=p;
   end -- feature setpNext
end -- class tnode


deferred class iterator		    --class iterator
	feature 	start is deferred end
				weiter is deferred end
      	   isFertig:boolean is deferred end
         	aktuellesElement:Integer is deferred end
end -- class iterator


class l_iterate					--	class l_iterate
	inherit iterator
   end -- inherit iterator

	creation init

   feature pFirst,aktuell:tnode;

	feature init(l:tnode) is
   do
     pFirst:=l;
     aktuell:=void;
   end -- feature init

   feature start is
   do
     aktuell:=pFirst;
   end -- feature start

   feature weiter is
   do
     aktuell:=aktuell.pNext;
   end -- feature weiter

   feature isFertig:Boolean is
   do
     result:=(aktuell=void);
   end -- feature isFertig

   feature aktuellesElement:Integer is
   do
     Result:=aktuell.data;
   end -- feature aktuellesElement
end -- class l_iterate


deferred class aliste			--class aliste
	feature 	erzeugeIterator:Iterator is deferred end
				anzahl:integer is deferred end
      	   add(e:integer) is deferred end
end -- class aliste


class list 							--class list
	inherit aliste
	end -- inherit aliste

	creation init

	feature pFirst,pLast:tnode;

	feature init is
   do
   	pFirst:=void;
      pLast:=void;
   end -- feature init

	feature erzeugeIterator:Iterator is
   local i:l_iterate
	do
		!!i.init(pFirst);
		result:=i;
	end -- feature erzeugeIterator

	feature anzahl:Integer is
   local i:integer;
   		h:tnode;
	do
      i:=0;
      from h:=pFirst until h=void loop
      	i:=i+1; h:=h.pNext;
      end -- from h
		Result:=i;
	end -- feature anzahl

	feature add(e:integer) is
   local h:tnode;
	do
	 	!!h.init;
     	h.setdata(e);
     	h.setpNext(void);
	 	if pFirst=void then pFirst:=h
      else pLast.setpNext(h)end
    	pLast:=h;
	end -- feature add

   feature dump is
   local h:tnode
   require pFirst<>void   
	do
      from h:=pFirst until h=void loop
      	print(h.data);print(" "); h:=h.pNext;
      end -- from h
      print("Ende%N");
   end -- feature dump


end -- class list


class MAIN							--class MAIN
	creation make
	feature {NONE} -- Creation
		make (args : ARRAY [STRING]) is
	   local psis:STANDARD_INPUT_STREAM; pbs:binary_input_stream;
   			l:list;
      	   e:integer;
            it:iterator;
		do
				e:=2;
     			!!l.init;
            l.add(2);
            l.add(4);
            l.add(7);
            l.dump;
            print("Dies war der Zugriff ueber die Liste selbst, jetzt kommt der Zugriff ueber den Iterator:%N");
            it:=l.erzeugeIterator;
            it.start;
            from it.start until it.isFertig loop
            	print(it.aktuellesElement);
               print(" ");
            	it.weiter;
            end -- from it.start
            print("Ende")
	          !!psis.make; !!pbs.make(psis); pbs.read_character;
		end -- make
end -- class MAIN
